<?php
 require_once NOALYSS_INCLUDE.'/database/currency_sql.class.php'; require_once NOALYSS_INCLUDE.'/database/currency_history_sql.class.php'; class Currency_MTable extends Manage_Table_SQL { function __construct(V_Currency_Last_Value_SQL $p_table) { parent::__construct($p_table); if ($this->is_currency_used($p_table->currency_id)==TRUE) { $this->set_delete_row(FALSE); } else { $this->set_delete_row(TRUE); } $this->set_property_visible("currency_id", FALSE); $this->set_property_visible("currency_history_id", FALSE); $this->set_col_label("cr_code_iso", "ISO"); $this->set_col_label("cr_name", _("Nom")); $this->set_col_label('ch_value', _("Valeur")); $this->set_col_label('str_from', _("Date")); $this->set_col_type("str_from", "date"); $this->a_order=array("cr_code_iso", "currency_id", "currency_history_id", "cr_name", "ch_value", "str_from"); $this->set_icon_mod("first"); $this->set_sort_column("cr_code_iso"); } function is_currency_used($p_id) { global $cn; $cnt_used=$cn->get_value(" select count(*) from jrn where currency_id=$1",[$p_id]); if ($cnt_used > 0) { return TRUE; } return FALSE; } function input() { $record=$this->get_table(); $cr_code_iso=new IText("cr_code_iso", $record->cr_code_iso); $cr_code_iso->size=10; $cr_name=new IText("cr_name", $record->cr_name); $cr_name->size=50; $a_histo=$record->cn->get_array("select id,to_char(ch_from,'DD.MM.YYYY') as str_from,ch_value 
               from 
                currency_history 
               where 
                currency_id=$1", array($record->currency_id)); $new_rate_date=new IDate("new_rate_date"); $new_rate_value=new INum("new_rate_value"); $new_rate_value->prec=6; if ($record->currency_id!=-1) { require NOALYSS_TEMPLATE."/currency_mtable_input.php"; } else { require NOALYSS_TEMPLATE."/currency_mtable_input_new.php"; } } function check() { global $cn; $table=$this->get_table(); $is_error=0; if ( $table->currency_id == 0) { $is_error++; $this->set_error("cr_code_iso", _("Devise par défaut ne peut être changée")); } if (trim($table->cr_code_iso)=="") { $is_error++; $this->set_error("cr_code_iso", _("Code iso ne peut pas être vide")); } if (trim($table->cr_name)=="") { $is_error++; $this->set_error("cr_name", _("Nom ne peut pas être vide")); } if ($table->currency_id==-1) { if (isDate($table->str_from)==0||trim($table->str_from)=="") { $is_error++; $this->set_error("str_from", _("Date incorrecte, il faut au moins une valeur")); } if (isNumber($table->ch_value)==0||trim($table->ch_value)=="") { $is_error++; $this->set_error("ch_value", _("Valeur incorrecte, il faut au moins une valeur")); } } else { if (trim($table->str_from) =="" && trim($table->ch_value)=="") { } elseif (trim($table->str_from)!=""&&trim($table->ch_value)!="") { if (isDate($table->str_from)==0) { $is_error++; $this->set_error("str_from", _("Date incorrecte")); } if (isNumber($table->ch_value)==0) { $is_error++; $this->set_error("ch_value", _("Valeur incorrecte")); } $count=$cn->get_value("select count(*) 
                        from 
                            currency_history 
                        where 
                            currency_id =$1 
                            and ch_from >= to_date($2,'DD.MM.YYYY') ", array($table->currency_id, $table->str_from)); if ($count>0) { $is_error++; $this->set_error("str_from", _("Date doit être après la dernière valeur")); } } elseif (trim($table->str_from)!=""||trim($table->ch_value)!="") { $is_error++; $this->set_error("str_from", _("Valeur manquante")); } } $cnt=$cn->get_value("select count(*) from currency where id != $1 and cr_code_iso=$2", array($table->currency_id, $table->cr_code_iso)); if ($cnt>0) { $is_error++; $this->set_error("cr_code_iso", _("Code ISO existe déjà")); } if ( trim(mb_strlen($table->cr_code_iso))>10) { $is_error++; $this->set_error("cr_code_iso", _("Code ISO trop long max = 10")); } if ( trim(mb_strlen($table->cr_name))>80) { $is_error++; $this->set_error("cr_name", _("Nom trop long max=80")); } if ( $table->ch_value != "" && ($table->ch_value < 0 || $table->ch_value == 0)) { $is_error++; $this->set_error("ch_value", _("Valeur incorrecte")); } if ($is_error==0) { return TRUE; } return FALSE; } function save() { $cn=Dossier::connect(); try { $cn->start(); $record=$this->get_table(); if ($record->currency_id==-1) { $currency=new Currency_SQL($cn); $currency->setp("cr_code_iso", mb_strtoupper($record->cr_code_iso)); $currency->setp("cr_name", $record->cr_name); $currency->insert(); $currency_history=new Currency_history_SQL($cn); $currency_history->setp("ch_value", $record->ch_value); $currency_history->setp("ch_from", $record->str_from); $currency_history->setp("currency_id", $currency->id); $currency_history->insert(); $this->table->currency_id=$currency->id; $this->table->load(); } else { $currency=new Currency_SQL($cn, $record->currency_id); $currency->setp("cr_code_iso", mb_strtoupper($record->cr_code_iso)); $currency->setp("cr_name", $record->cr_name); $currency->update(); if ($record->str_from!="") { $currency_history=new Currency_history_SQL($cn); $currency_history->setp("ch_value", $record->ch_value); $currency_history->setp("ch_from", $record->str_from); $currency_history->setp("currency_id", $currency->id); $currency_history->insert(); } } $cn->commit(); } catch (Exception $ex) { $cn->rollback(); throw ($ex); } } function from_request() { $http=new HttpInput(); $this->table->cr_code_iso=mb_strtoupper($http->request("cr_code_iso")); $this->table->cr_name=$http->request("cr_name"); $this->table->currency_id=$http->request("p_id", "number"); $this->table->ch_value=$http->request("new_rate_value"); $this->table->str_from=$http->request("new_rate_date"); } function display_row($p_row) { if ($p_row['currency_id']==0) { $this->set_update_row(FALSE); $this->set_delete_row(FALSE); parent::display_row($p_row); return; } if ($this->is_currency_used($p_row['currency_id'])==TRUE) { $this->set_delete_row(FALSE); } else { $this->set_delete_row(TRUE); } $this->set_update_row(TRUE); parent::display_row($p_row); } function delete() { $id=$this->get_table()->currency_id; if ( $this->is_currency_used($id) == FALSE) $this->table->delete(); } } 