<?php
 #[AllowDynamicProperties] abstract class Data_SQL { var $cn; var $name; var $primary_key; var $type; var $date_format; var $default; var $table; public function __toString(): string { $ret="values "; foreach ($this->name as $name) { $ret.="[ $name => {$this->$name} ]"; } $ret.="| type ".print_r($this->type,true); $ret.="| default ".print_r($this->default,true); $ret.="| primary key ".$this->primary_key; $ret.="| date_format ".$this->date_format; return $ret; } function __construct(DatabaseCore $p_cn, $p_id=-1) { $this->cn=$p_cn; $pk=$this->primary_key; $this->$pk=$p_id; if (count($this->name) != count($this->type) ){ throw new Exception (__FILE__." $this->table Cannot instantiate"); } foreach ($this->name as $key) { if ( in_array($key,['name','type','format_date','cn','date_format','default'] ) ) { throw new Exception ('DATASQL-94 invalid column name'.$key); } $this->$key=null; } $this->$pk=$p_id; if ($p_id != -1 )$this->load(); if ( empty($this->date_format) ) $this->date_format="DD.MM.YYYY"; } public function save() { $count = $this->exist(); if ($count == 0) $this->insert(); else $this->update(); } public function get($p_string) { if (array_key_exists($p_string, $this->type)) { return $this->$p_string; } else throw new Exception(__FILE__.":".__LINE__.$p_string.'Erreur attribut inexistant '.$p_string); } public function set($p_string, $p_value) { if (array_key_exists($p_string, $this->type)) { $this->$p_string=$p_value; return $this; } else throw new Exception(__FILE__.":".__LINE__.$p_string.'Erreur attribut inexistant '.$p_string); } public function getp($p_string) { if (array_key_exists($p_string, $this->name)) { $idx=$this->name[$p_string]; return $this->$idx; } else throw new Exception(__FILE__.":".__LINE__.$p_string.'Erreur attribut inexistant '.$p_string); } public function setp($p_string, $p_value) { if (array_key_exists($p_string, $this->name)) { $idx=$this->name[$p_string]; $this->$idx=$p_value; return $this; } else throw new Exception(__FILE__.":".__LINE__.$p_string.'Erreur attribut inexistant '.$p_string); } abstract function insert(); abstract function delete(); abstract function update(); public function set_pk_value($p_value) { $pk=$this->primary_key; $this->$pk=$p_value; } public function get_pk_value() { $pk=$this->primary_key; return $this->$pk; } abstract function load():bool; public function get_info() { return var_export($this, true); } public function verify() { foreach ($this->name as $key) { if (noalyss_trim($this->$key)=='') $this->$key=null; } return 0; } public function from_array($p_array) { foreach ($this->name as $key=> $value) { if (isset($p_array[$value])) { $this->$value=$p_array[$value]; } else { $this->$value=null; } } return $this; } public function to_array($prefix="") { $array=array(); foreach ($this->name as $key=> $value) { $nkey=$prefix.$key; $array[$key]=$this->$key; } return $array; } public function to_row($p_array) { foreach ($this->name as $name) { $this->$name=$p_array[$name]; } } abstract function seek($cond='', $p_array=null); public function next($ret, $i) { $array=$this->cn->fetch_array($ret, $i); return $this->from_array($array); } public function get_object($p_ret, $idx) { return $this->next($p_ret, $idx); } function collect_objects($cond='', $p_array=null) { if ($p_array != null && ! is_array($p_array) ) { throw new Exception(_("Erreur : exec_sql attend un array")); } $ret=$this->seek($cond, $p_array); $max=Database::num_row($ret); $a_return=array(); for ($i=0; $i<$max; $i++) { $a_return[$i]=clone $this->next($ret, $i); } return $a_return; } abstract function count($p_where="",$p_array=null) ; abstract function exist() ; public function get_cn() { return $this->cn; } public function get_name() { return $this->name; } public function get_primary_key() { return $this->primary_key; } public function get_type() { return $this->type; } public function set_cn($cn) { $this->cn=$cn; return $this; } public function set_name($name) { $this->name=$name; return $this; } public function set_primary_key($primary_key) { $this->primary_key=$primary_key; return $this; } public function set_type($type) { $this->type=$type; return $this; } } ?>
